Subject: Re: Question about HFSC atm+man patches

From: Patrick McHardy <[email-masked]>
Date: Mon, 24 Nov 2008 15:11:22 +0100

Michal Soltys wrote:
> Patrick McHardy wrote:
>> Michal Soltys wrote:
>>> Would such approach be valid and possibly accepted ?
>>
>> We already support generic size adjustment for all qdiscs. I'm
>> not sure about the userspace interface though.
>>
> 
> More about what I have in mind - in april '08 there was set of 8 patches
> -
> http://kerneltrap.org/mailarchive/linux-netdev/2008/4/9/1386524/thread#mid-1386524 
> 
> 
> They added atm adaptation to tbf, htb, cbq and filter's action police.
> The rate table is precalculated in userspace, and depending on tc
> invocation - will be either unaltered, or the times will be set
> according to lengths aligned to atm cells (tc_calc_rtable, in 
> tc/tc_core.c).
> 
> On the kernel's side, rata table is consulted through qdisc_l2t
> function, where overhead and cell_align are taken into account as well.
> 
> Anyway - HFSC wasn't included in that patchset, as it didn't use rate
> table - so what I have in mind is essentially:
> 
> len = hfsc_l2_adapt(q->overhead,qdisc_pkt_len(skb));
> 
> instead of
> 
> len = qdisc_pkt_len(skb);

qdisc_pkt_len already returns an adjusted length based on "size tables".
Check out qdisc_enqueue()/qdisc_enqueue_root() for details.

Is there something missing for overhead calculation?